<?php
namespace Teknisa\Model\Avaliacao\Repositories;


class Questao extends \Doctrine\ORM\EntityRepository {
    
    public function retornaQuestoesAgrupamentoItemApuResult($params, $paramRelacionamento = false){
       $sql = "SELECT QUESTAVALIACAO.NRQUESTAO,
                  QUESTAO.TXQUESTAO,
                  QUESTAVALIACAO.NRQUESTAVALIA
                FROM PARCNEGOCIO EXEC,
                  PARCNEGOCIO APLIC,
                  TIPORELACIONA,
                  QUESTAO,
                  RESPOSTA,
                  EXECAVALIACAO,
                  RESPAVALIACAO,
                  AVALIACAOGERAL,
                  PARTICIPAVAL,
                  COMBQUESTAVAL,
                  QUESTAVALIACAO,
                  TIPORELACAVAL,
                  AGRUPQUESTAVAL
                WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                AND EXECAVALIACAO.NRAVALIACAO      = AVALIACAOGERAL.NRAVALIACAO
                AND AVALIACAOGERAL.NRAVALIACAO     = PARTICIPAVAL.NRAVALIACAO
                AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                AND (AVALIACAOGERAL.NRAVALIACAO    = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                AND AVALIACAOGERAL.NRAVALIACAO     = TIPORELACAVAL.NRAVALIACAO
                AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                  /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                AND RESPOSTA.VRPESORESPOSTA > -1";

       if ($paramRelacionamento) {
       $sql .= "  AND QUESTAO.NRQUESTAO NOT    IN
                  (SELECT QUESTAO.NRQUESTAO
                  FROM PARCNEGOCIO EXEC,
                    PARCNEGOCIO APLIC,
                    TIPORELACIONA,
                    QUESTAO,
                    RESPOSTA,
                    EXECAVALIACAO,
                    RESPAVALIACAO,
                    PARTICIPAVAL,
                    COMBQUESTAVAL,
                    QUESTAVALIACAO,
                    TIPORELACAVAL,
                    AGRUPQUESTAVAL
                  WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                  AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                  AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                  AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                  AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                  AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                  AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                  AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                  AND PARTICIPAVAL.NRAVALIACAO       = :P_NRAVALIACAO
                  AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                  AND (:P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                  AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                  AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                  AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                  AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                  AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                  AND :P_NRAVALIACAO                 = TIPORELACAVAL.NRAVALIACAO
                  AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                    /* filtra questoes que receberam resposta como NAO SE APLICA */
                  AND RESPOSTA.VRPESORESPOSTA = -1
                    /* filtra com o maior peso existente para a avaliacao*/
                  AND TIPORELACIONA.NRTIPORELACIONA IN
                    (SELECT TIPORELACIONA.NRTIPORELACIONA
                    FROM TIPORELACAVAL,
                      TIPORELACIONA
                    WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                    AND TIPORELACAVAL.VRPESORELACAVAL   =
                      (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
                      FROM TIPORELACAVAL
                      WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                      )
                    AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                    )
                  AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                  AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                  AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                  AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                  AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                  )";
       }

        $sql .= "  AND TIPORELACIONA.NRTIPORELACIONA IN
                  (SELECT TIPORELACIONA.NRTIPORELACIONA
                  FROM TIPORELACAVAL,
                    TIPORELACIONA
                  WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                  AND TIPORELACAVAL.VRPESORELACAVAL   =
                    (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
                    FROM TIPORELACAVAL
                    WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                    )
                  AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                  )
                AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                GROUP BY QUESTAVALIACAO.NRQUESTAO,
                  QUESTAO.TXQUESTAO,
                  TIPORELACIONA.NMTIPORELACIONA,
                  TIPORELACAVAL.VRPESORELACAVAL,
                  AGRUPQUESTAVAL.NMAGRUPQUESTAVA,
                  QUESTAVALIACAO.NRQUESTAVALIA
                ORDER BY QUESTAVALIACAO.NRQUESTAO";
                
        return $this->getEntityManager()->createQuery($sql)->execute($params); 
        
    }
    
    public function retornaResultadoPonderadoQuestaoRepository($params, $paramRelacionamento = false){
    $sqlResult = "SELECT ROUND((SUM(SUM(MEDIA_RELAC) / SUM(PESORELAC)) / COUNT(NRQUESTAO)), 2) RESULTADO
                    FROM
                      (SELECT QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL                                    AS PESORELAC,
                        ( AVG(RESPOSTA.VRPESORESPOSTA) * TIPORELACAVAL.VRPESORELACAVAL ) AS MEDIA_RELAC,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      FROM PARCNEGOCIO EXEC,
                        PARCNEGOCIO APLIC,
                        TIPORELACIONA,
                        QUESTAO,
                        RESPOSTA,
                        EXECAVALIACAO,
                        RESPAVALIACAO,
                        AVALIACAOGERAL,
                        PARTICIPAVAL,
                        COMBQUESTAVAL,
                        QUESTAVALIACAO,
                        TIPORELACAVAL,
                        AGRUPQUESTAVAL
                      WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                      AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                      AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                      AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                      AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                      AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                      AND EXECAVALIACAO.NRAVALIACAO      = AVALIACAOGERAL.NRAVALIACAO
                      AND AVALIACAOGERAL.NRAVALIACAO     = PARTICIPAVAL.NRAVALIACAO
                      AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                      AND (AVALIACAOGERAL.NRAVALIACAO    = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                      AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                      AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                      AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                      AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                      AND AVALIACAOGERAL.NRAVALIACAO     = TIPORELACAVAL.NRAVALIACAO
                      AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                        /* IGNORA questoes que receberam resposta como NAO SE APLICA */
                      AND RESPOSTA.VRPESORESPOSTA > -1";

    if ($paramRelacionamento) {
    $sqlResult .= "   AND QUESTAO.NRQUESTAO NOT IN
                        (SELECT QUESTAO.NRQUESTAO
                        FROM PARCNEGOCIO EXEC,
                          PARCNEGOCIO APLIC,
                          TIPORELACIONA,
                          QUESTAO,
                          RESPOSTA,
                          EXECAVALIACAO,
                          RESPAVALIACAO,
                          PARTICIPAVAL,
                          COMBQUESTAVAL,
                          QUESTAVALIACAO,
                          TIPORELACAVAL,
                          AGRUPQUESTAVAL
                        WHERE QUESTAO.NRQUESTAO            = RESPOSTA.NRQUESTAO
                        AND QUESTAO.NRQUESTAO              = EXECAVALIACAO.NRQUESTAO
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = QUESTAVALIACAO.NRAGRUPQUESTAVA
                        AND RESPOSTA.NRRESPOSTA            = RESPAVALIACAO.NRRESPOSTA
                        AND EXECAVALIACAO.NREXECAVALIACAO  = RESPAVALIACAO.NREXECAVALIACAO
                        AND EXEC.NRPARCNEGOCIO             = EXECAVALIACAO.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = EXECAVALIACAO.NRPARCAVALIADO
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND PARTICIPAVAL.NRAVALIACAO       = :P_NRAVALIACAO
                        AND TIPORELACIONA.NRTIPORELACIONA  = PARTICIPAVAL.NRTIPORELACIONA
                        AND (:P_NRAVALIACAO                = COMBQUESTAVAL.NRAVALIACAO OR COMBQUESTAVAL.NRAVALIACAO IS NULL)
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = QUESTAVALIACAO.NRCOMBQUESTAVAL
                        AND QUESTAVALIACAO.NRQUESTAO       = QUESTAO.NRQUESTAO
                        AND COMBQUESTAVAL.NRCOMBQUESTAVAL  = PARTICIPAVAL.NRCOMBQUESTAVAL
                        AND EXEC.NRPARCNEGOCIO             = PARTICIPAVAL.NRPARCEXECAVAL
                        AND APLIC.NRPARCNEGOCIO            = PARTICIPAVAL.NRPARCAVALIADO
                        AND :P_NRAVALIACAO                 = TIPORELACAVAL.NRAVALIACAO
                        AND TIPORELACAVAL.NRTIPORELACIONA  = TIPORELACIONA.NRTIPORELACIONA
                          /* filtra questoes que receberam resposta como NAO SE APLICA */
                        AND RESPOSTA.VRPESORESPOSTA = -1
                          /* filtra com o maior peso existente para a avaliacao*/
                        AND TIPORELACIONA.NRTIPORELACIONA IN
                          (SELECT TIPORELACIONA.NRTIPORELACIONA
                          FROM TIPORELACAVAL,
                            TIPORELACIONA
                          WHERE TIPORELACAVAL.NRTIPORELACIONA = TIPORELACIONA.NRTIPORELACIONA
                          AND TIPORELACAVAL.VRPESORELACAVAL   =
                            (SELECT MAX(TIPORELACAVAL.VRPESORELACAVAL)
                            FROM TIPORELACAVAL
                            WHERE TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                            )
                          AND TIPORELACAVAL.NRAVALIACAO = :P_NRAVALIACAO
                          )
                        AND EXECAVALIACAO.NRQUESTAO        = :P_NRQUESTAO
                        AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                        AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                        AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                        AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                        AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                        )";
    }

    $sqlResult .= "   AND EXECAVALIACAO.NRQUESTAO        = :P_NRQUESTAO
                      AND AGRUPQUESTAVAL.NRAGRUPQUESTAVA = :P_NRAGRUPQUESTAVA
                      AND EXECAVALIACAO.NRAVALIACAO      = :P_NRAVALIACAO
                      AND EXECAVALIACAO.NRCOMBQUESTAVAL  = :P_NRCOMBQUESTAVAL
                      AND EXECAVALIACAO.NRPARCAVALIADO   = :P_NRPARCAVALIADO
                      AND PARTICIPAVAL.IDSITUACAOAVAL    = 'CONCLUIDA'
                      GROUP BY QUESTAVALIACAO.NRQUESTAO,
                        QUESTAO.TXQUESTAO,
                        TIPORELACIONA.NMTIPORELACIONA,
                        TIPORELACAVAL.VRPESORELACAVAL,
                        AGRUPQUESTAVAL.NMAGRUPQUESTAVA
                      ORDER BY QUESTAVALIACAO.NRQUESTAO
                      )
                    GROUP BY NRQUESTAO
                    ORDER BY NRQUESTAO";
        return $this->getEntityManager()->createQuery($sql)->execute($params);
    }

    
}